/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Data;
using System.Data.OleDb;

namespace ShopClassLibrary
{
	public interface IProduct
	{
		DataSet GetByID(string User, string Pass, int ProductID);
		DataSet FindByName(string User, string Pass, string NamePattern);
		int GetStock(string User, string Pass, int ProductID, out ShopStatusEnum status);
		ShopStatusEnum InStock(string User, string Pass, int ProductID, int Quant);
		ShopStatusEnum AddStock(string User, string Pass, int ProductID, int Quant);
	}

	/// <summary>
	/// Summary description for Product.
	/// </summary>
	internal class Product : IProduct
	{
		#region IProduct
		/// <summary>
		/// pesquisa um determinado produto por cdigo de produto
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns>a informao do produto</returns>
		public DataSet GetByID(string User, string Pass, int ProductID)
		{
			return null;
		}

		/// <summary>
		/// pesquisa produtos por nome
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns>informao dos produtos que obedeam ao critrio de busca</returns>
		public DataSet FindByName(string User, string Pass, string NamePattern)
		{
			return null;
		}

		/// <summary>
		/// devolve a quantidade em stock de um determinado produto
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <param name="ProductID">cdigo de produto a pesquizar</param>
		/// <param name="status"></param>
		/// <returns></returns>
		public int GetStock(string User, string Pass, int ProductID, out ShopStatusEnum status)
		{
			status = ShopStatusEnum.OK;
			return 0;
		}

		/// <summary>
		/// verifica se existe uma determinada quantidade de um produto em armazem 
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <param name="ProductID">cdigo de produto a pesquizar</param>
		/// <param name="Quant">quantidade desejada de produto</param>
		/// <returns>cdigo de estado relativo  operao</returns></returns></returns>
		public ShopStatusEnum InStock(string User, string Pass, int ProductID, int Quant)
		{
			return ShopStatusEnum.OK;
		}

		public ShopStatusEnum AddStock(string User, string Pass, int ProductID, int Quant)
		{
			return ShopStatusEnum.OK;
		}
		#endregion
	}
}
