using System;
using System.Data;
using ShopClassLibrary;

namespace TestShopConsole
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class AppMain
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			IUser u = Factory.CreateUserService();
			ShopStatusEnum status = u.Validate("joao", "joao");

			TesteGetCustomer();
			TestAddCustomer();
			TesteAddSale();

			Console.WriteLine("\n\nQQ tecla para continuar...");
			Console.ReadLine();
		}

		public static void TesteGetCustomer()
		{
			// ICustomer c = new Customer();
			ICustomer c = Factory.CreateCustomerService();

			DataSet oDS = c.GetByID("joao", "joao", 27);

			foreach(DataRow myRow in oDS.Tables["Customers"].Rows)
			{
				Console.WriteLine(myRow["Name"]);

				//foreach(DataColumn myCol in oDT.Columns)
				//{
				//	Console.WriteLine(myRow[myCol]);
				//}
			}
		}

		public static void TestAddCustomer()
		{
			Console.WriteLine("TESTE 'Customer' -->\n\n");

			//
			// criar objecto
			//
			// ICustomer oCust = new Customer();
			ICustomer oCust = Factory.CreateCustomerService();

			//
			// invocar mtodo
			//
			ShopStatusEnum status;
			long custID;
			custID = oCust.Add("joao", "joao", "outro cliente", "outra morada", "telefone", "fax", "email", out status);

			Console.WriteLine("Customer.AddCustomer: status={0}, CustomerID={1}\n", status, custID);		
		}

		public static void TesteAddSale()
		{
			// ISale c = new Sale();
			ISale s = Factory.CreateSaleService();

			DataSet ds = s.CreateDetails("joao", "joao");

			DataRow dr = ds.Tables["SaleDetails"].NewRow();
			dr["productid"] = 8;
			dr["quantity"] = 3;
			ds.Tables["SaleDetails"].Rows.Add(dr);

			dr = ds.Tables["SaleDetails"].NewRow();
			dr["productid"] = 9;
			dr["quantity"] = 10;
			ds.Tables["SaleDetails"].Rows.Add(dr);

			//ds.AcceptChanges();

			ShopStatusEnum status = s.Add("joao", "joao", 27, DateTime.Now, ds);

			Console.WriteLine("Sale.AddSale: status={0}\n", status);		
		}
	}
}
